unit Vraag1_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, Menus, DB, Grids, DBGrids, ADODB;

type
  TForm1 = class(TForm)
    qrySkool: TADOQuery;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    BitBtn1: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure SetGridColumnWidths(Grid: Tdbgrid);
const
  DEFBORDER = 10;
var
  temp, n: Integer;
  lmax: array [0..30] of Integer;
begin
  with Grid do
  begin
    Canvas.Font := Font;
    for n := 0 to Columns.Count - 1 do
      lmax[n] := Canvas.TextWidth(Fields[n].FieldName) + DEFBORDER;
    grid.DataSource.DataSet.First;
    while not grid.DataSource.DataSet.EOF do
    begin
      for n := 0 to Columns.Count - 1 do
      begin
        temp := Canvas.TextWidth(trim(Columns[n].Field.DisplayText)) + DEFBORDER;
        if temp > lmax[n] then lmax[n] := temp;
      end; {for}
      grid.DataSource.DataSet.Next;
    end;
    grid.DataSource.DataSet.First;
    for n := 0 to Columns.Count - 1 do
      if lmax[n] > 0 then
        Columns[n].Width := lmax[n];
  end;
end; {SetGridColumnWidths}

procedure TForm1.Button1Click(Sender: TObject);
begin
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Select * from OnderwysersTb order by van';
  qrySkool.Active := true;
  SetGridColumnWidths(DBGrid1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Select Titel, Van, Onderwyserskode from OnderwysersTb where (vakke = "ENG" or vakke = "AFR" or vakke = "XHO") ';
  qrySkool.Active := true;
  SetGridColumnWidths(DBGrid1);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  svak : string;
begin
  svak := inputbox('Lees vakkode in','','');
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Select count(*) as [Potensile Vakgetalle] from LeerdersTb where (VK5 = "'+svak+'")';
  qrySkool.Active := true;
  SetGridColumnWidths(DBGrid1);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Select Naam, Van from LeerdersTb where Onderwysers like "%AM%"';
  qrySkool.Active := true;
  SetGridColumnWidths(DBGrid1);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Update LeerdersTb Set VK5 = "LWET" where VK5 = "KUNS"';
  qrySkool.Active := true;
  qrySkool.SQL.Text := 'Select * from LeerdersTb';
  SetGridColumnWidths(DBGrid1);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Select klas, count(klas) AS [Klasgrootte] from LeerdersTb group by klas';
  qrySkool.Active := true;
  SetGridColumnWidths(DBGrid1);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  qrySkool.active := false;
  qrySkool.SQL.Text := 'Select * from LeerdersTb where (VK7 = "VERB" or VK7 = "TOER") and (klas = "G")';
  qrySkool.Active := true;
  SetGridColumnWidths(DBGrid1);
end;

end.

